#include <stddef.h>

// 插件信息结构体
typedef struct dpkgPlugin_s * dpkgPlugin;
// 插件列表结构体
typedef struct dpkgPlugins_s * dpkgPlugins;
// 钩子函数结构体
typedef struct dpkgPluginHooks_s * dpkgPluginHooks;
// deb信息结构体
typedef struct debts_s * debts;

typedef int (*plugin_init_func)(dpkgPlugin plugin); //加载插件时被调用
typedef int (*plugin_cleanup_func)(dpkgPlugin plugin); //清楚插件空间时被调用
typedef int (*plugin_pre_inst_func)(dpkgPlugin plugin, debts ts); //安装包之前被调用
typedef int (*plugin_pre_uninst_func)(dpkgPlugin plugin, debts ts); //卸载包之前被调用

//钩子函数定义
struct dpkgPluginHooks_s{
	plugin_init_func	init;
	plugin_cleanup_func	cleanup;
	plugin_pre_inst_func	pre_inst;
	plugin_pre_uninst_func	pre_uninst;
};

// deb信息结构体
struct debts_s{
	char * debname;
};

// 给dpkgPlugins分配空间
dpkgPlugins dpkgpluginsNew(debts ts);
//添加插件
int dpkgpluginsAddPlugin(dpkgPlugins plugins);
// 执行钩子函数
int dpkgpluginsCallTsmInst(dpkgPlugins plugins, debts ts);
// 执行钩子函数
int dpkgpluginsCallTsmUinst(dpkgPlugins plugins, debts ts);
// 释放dpkgPlugins空间
dpkgPlugins dpkgpluginsFree(dpkgPlugins plugins);
